# Input Encoder

The input encoder generates a sample with index `idx` from the [PreprocessResponse](/tensorleap-integration/python-api/code_loader/datasetclasses/preprocessresponse.md)  object. This sample will later be fetched as input by the network. The function is called for every evaluated sample. There should be a separate encoder for each input.

The [@tensorleap\_input\_encoder](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_input_encoder.md) decorator registers each input encoder into the Tensorleap integration.

```python
from code_loader.contract.datasetclasses import PreprocessResponse
from code_loader.inner_leap_binder.leapbinder_decorators import tensorleap_input_encoder

@tensorleap_input_encoder(name='image', channel_dim=-1)
def input_encoder(idx: int, preprocess: PreprocessResponse) -> np.ndarray:
    return preprocess.data.iloc[idx]['samples'].astype('float32')
```

Usage within the full script can be found at the [**Dataset Script**](/tensorleap-integration/writing-integration-code.md#dataset-script).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tensorleap.ai/tensorleap-integration/writing-integration-code/input-encoder.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
